image: gradle:8.6.0-jdk21

variables:
  GRADLE_USER_HOME: "${CI_PROJECT_DIR}/api-gateway/.gradle"
  GRADLE_OPTS: "-Dorg.gradle.daemon=false -Dorg.gradle.parallel=false -Dorg.gradle.configureondemand=false"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - ${CI_PROJECT_DIR}/api-gateway/.gradle
    - api-gateway/build/

stages:
  - build
  - build-app-image

build:
  stage: build
  script:
    - cd api-gateway
    - chmod +x ./gradlew
    - ./gradlew build
  only:
    - main

build-app-image:
  stage: build-app-image
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - echo "$CI_JOB_TOKEN" | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY
  script:
    - cd api-gateway
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"
  only:
    - main
